lappend auto_path [pwd]
package require Winico

if {![file exist "tkblog.cfg" ]} {
    wm iconify .
    tk_messageBox -title "ERROR!" -icon error -message  "Couldn't find \
                                                        tkblog.cfg"
    exit
} else {
    source ./tkblog.cfg
}

namespace eval blggv {
          variable version        "Blog v2.25"
          variable logname        "blog.log"
          variable newsession     1
          variable logid          "--"
          variable blogtemplate   "blog.template"
          variable blogdata       "archive/blog.dat"
          variable blogtemp       "tmp/blogtemp"
          variable today          [clock seconds]
          variable days           [expr {86400 * $days}]
          variable start          [clock format [clock seconds] -format "%c"]
          variable blog
          variable blgtmplt
          variable blgtmp
          variable blgtmpdata
          variable blogd
          variable blogt
          variable date_format    $date_format
          variable time_format    $time_format
          variable blgtmpdata1
          variable bloghtml       $bloghtml
          variable server         $server
          variable user           $user
          variable passwd         $passwd
          variable arcdir         $arcdir
          variable archtml        $archtml
          variable enable_archive $enable_archive
}

package require ftp

proc logmsg {msg} {

      set  timestamp [clock format [clock seconds] -format "%d %b %H:%M:%S"]
      set  logfile [open $blggv::logname a+]

      if {$blggv::newsession==1} {
         puts $logfile "\n  $timestamp  $blggv::logid $msg"
        .logwindow.buffer insert end "\n  $timestamp  $blggv::logid $msg\n"
        .logwindow.buffer see end; update idle
         set blggv::newsession 0
      }  else {
         puts $logfile "  $timestamp  $blggv::logid $msg"
        .logwindow.buffer insert end "  $timestamp  $blggv::logid $msg\n"
        .logwindow.buffer  see end; update idle
      }

      close $logfile;
}
proc createblogentry {} {

     set blggv::blog [.blog.buffer get 1.0 end]
}
proc parseline {line} {

     if {[regexp {<!--blog-->} $line]} {
          puts $blggv::blgtmp $line
          #set blggv::blogd [clock format [clock seconds] -format "%A, %B %d/%Y"]
          set blggv::blogd [clock format [clock seconds] -format $blggv::date_format]
          #set blggv::blogt [clock format [clock seconds] -format "  %I:%M %p"]
          set blggv::blogt [clock format [clock seconds] -format $blggv::time_format]
          set ds    [clock scan today]
          logmsg "blog timestamp: $blggv::blogd $blggv::blogt"
          logmsg "blogid: $ds"
          puts $blggv::blgtmpdata "<!-- blogid $ds -->"
          puts $blggv::blgtmpdata  "<a name=\"$ds\"><\/a>"

          while {[gets $blggv::blgtmplt line]!=-1} {
                  if {![regexp {<!--/blog-->} $line]} {
                       if {[regexp   {<\$blogdate>} $line] || \
                           [regexp   {<\$blogtime>} $line]} {
                           set line  [regsub {<\$blogdate>} $line $blggv::blogd subline]
                           set line $subline
                           set line  [regsub {<\$blogtime>} $line $blggv::blogt subline]
                           puts $blggv::blgtmpdata $subline
                       } elseif {[regexp {<\$blogentry>} $line]} {
                           set line  [regsub {<\$blogentry>} $line $blggv::blog subline]
                            puts -nonewline $blggv::blgtmpdata $subline
                       } else {
                            puts $blggv::blgtmpdata $line
                       }
                  } else {
                       puts $blggv::blgtmp     "$line\n"
                       puts $blggv::blgtmpdata "$line\n"
                       return
                  }
          }
     }
     puts $blggv::blgtmp $line
}
proc parseblogtemplate {} {

     set blggv::blgtmpdata [open "tmp/blgtmpdata" w]
     set blggv::blgtmp     [open $blggv::blogtemp w]
     set blggv::blgtmplt   [open $blggv::blogtemplate]

     while {[gets $blggv::blgtmplt line]!=-1} {
             parseline $line
     }
     close $blggv::blgtmpdata
     close $blggv::blgtmp
     close $blggv::blgtmplt
}
proc createblogdata {} {

     set blggv::blgtmpdata      [open "tmp/blgtmpdata"]
     set blggv::blgtmpdata1     [open "tmp/blgtmpdata1" w]

     while {[gets $blggv::blgtmpdata line]!=-1} {
             puts $blggv::blgtmpdata1 $line
     }
     close $blggv::blgtmpdata
     if {[file exists $blggv::blogdata]} {
          set blgdata  [open $blggv::blogdata]
          while {[gets $blgdata line]!=-1} {
                  puts $blggv::blgtmpdata1 $line
          }
          close $blgdata
     }
     close $blggv::blgtmpdata1
     file copy -force "tmp/blgtmpdata1" $blggv::blogdata
}
proc gblgdnacb {} {

     set blgtmp      [open $blggv::blogtemp]
     set blgdata     [open $blggv::blogdata]
     set blog        [open $blggv::bloghtml w]

     while {[gets $blgtmp line]!=-1} {
            if {[regexp {<!--blog-->} $line]} {
                 while {[gets $blgdata line]!=-1} {
                         if {[regexp {<!-- blogid*} $line]} {
                             set keep $line
                             set bid [split $line]
                             set bid [lindex $bid 2]
                             set elapsed [expr $blggv::today - $bid]
                             if {$elapsed <= $blggv::days} {
                                  puts $blog $keep
                                  while {[gets $blgdata line]!=-1} {
                                         if {![regexp {<!--/blog-->} $line]} {
                                               puts $blog $line
                                         } else {
                                               puts $blog "\n"
                                               break
                                         }
                                  }
                             }
                         }
                 }
            }
            if {![regexp {<!--/blog-->} $line]} {
                puts $blog $line
            }
     }
     close $blgdata
     close $blgtmp
     close $blog
}

proc cleanup {} {

     if {[file exists "tmp/blgtmpdata"]} {
          catch [file delete "tmp/blgtmpdata"]
     }
     if {[file exists "tmp/blgtmpdata1" ]} {
          catch [file delete "tmp/blgtmpdata1"]
     }
     if {[file exists $blggv::blogtemp]} {
          catch [file delete $blggv::blogtemp]
     }
}
proc clearwindow {} {
     .blog.buffer delete 1.0 end
     logmsg "new blog"
}
proc createarc {} {
     set blogdat [open $blggv::blogdata]
     set archive [open "archive/$blggv::archtml" w]
     set header  [open "header.template"]
     set footer  [open "footer.template"]

     while {[gets $header line]!=-1} {
           puts $archive $line
     }
     close $header
     while {[gets $blogdat line]!=-1} {
           puts $archive $line
     }
     close $blogdat
     while {[gets $footer line]!=-1} {
           puts $archive $line
     }
     close $footer
     close $archive
}
proc publish {} {

     logmsg "Getting ftp connection"
     if {[set conn [ftp::Open $blggv::server $blggv::user $blggv::passwd -progress Progress -blocksize 1024 -mode active]] == -1} {
          tk_messageBox -title "ERROR!" -icon error -message  "Can't connect to $blggv::server"
          logmsg "Connection refused!"
          return
     }
     logmsg "Sending blog to web page..."
     if {[catch [ftp::Put $conn $blggv::bloghtml $blggv::bloghtml]]} {
          logmsg "Sent $blggv::bloghtml"
     } else {
          tk_messageBox -title "ERROR!" -icon error -message  "Can't send to $blggv::server"
          logmsg "Can't send to $blggv::server $blggv::bloghtml NOT sent"
          return
     }
     logmsg "Sending archive to web page..."
     if {[catch [ftp::Put $conn "archive/$blggv::archtml"  $blggv::arcdir$blggv::archtml]]} {
          logmsg "Sent $blggv::archtml"
     } else {
          tk_messageBox -title "ERROR!" -icon error -message  "Can't send to $blggv::server"
          logmsg "Can't send to $blggv::server $blggv::archtml NOT sent"
          return
     }
}

wm geometry . +50+50
wm title . $blggv::version
wm resizable . 0 0
wm minsize . 150 100
frame .mbf
button .mbf.new     -disabledforeground grey -text "New Blog" \
                    -command { clearwindow
                               .mbf.publish config -state normal
                             }
button .mbf.publish -disabledforeground grey -text "Publish"  \
                     -command {.mbf.publish config -state disabled
                               .mbf.new     config -state disabled
                               .mbf.quit    config -state disabled
                               .mba.resend  config -state disabled 
                               .mba.archive config -state disabled 
                                createblogentry
                                parseblogtemplate
                                createblogdata
                                gblgdnacb
                                createarc
                                publish
                               .mbf.new  config   -state normal
                               .mbf.quit config   -state normal
                               .mba.resend config -state normal
                                if {$blggv::enable_archive==1} {
                                   .mba.archive config -state normal
                                }
                              }
button .mbf.quit  -disabledforeground grey  -text "Quit"  \
                  -command { cleanup
                             logmsg "Blog exit"
                             after 1000 exit
                           }
   frame .mba
   button .mba.resend  -disabledforeground grey -text "Resend" \
                       -command {.mbf.publish config -state disabled
                                 .mbf.new     config -state disabled
                                 .mbf.quit    config -state disabled
                                 .mba.resend  config -state disabled 
                                 .mba.archive config -state disabled 
                                 publish
                                 .mbf.new  config   -state normal
                                 .mbf.quit config   -state normal
                                 .mba.resend config -state normal
                                  if {$blggv::enable_archive==1} {
                                     .mba.archive config -state normal
                                  }
                        }
   button .mba.archive -disabledforeground grey -text "Archive" \
                       -command {.mbf.publish config -state disabled
                                 .mbf.new     config -state disabled
                                 .mbf.quit    config -state disabled
                                 .mba.resend  config -state disabled 
                                 .mba.archive config -state disabled 
                                 if {$tcl_platform(platform)=="windows"} {
                                     if {[catch [exec blarc.exe]]} {
                                        tk_messageBox -title "ERROR!" -icon error -message \
                                                      "Couldn't find  blarc.exe!"
                                       logmsg "Couldn't find  blarc.exe!"
                                       .mbf.publish config -state normal
                                       .mbf.new     config -state normal
                                       .mbf.quit    config -state normal
                                       .mba.resend  config -state normal
                                        return
                                     }
                                 } else {
                                   source ./blarc.tcl
                                 }
                                 .mbf.publish config -state normal
                                 .mbf.new     config -state normal
                                 .mbf.quit    config -state normal
                                 .mba.resend  config -state normal
                                 .mba.archive config -state normal
                        }

frame .blog
text .blog.buffer  -yscrollcommand  ".blog.sb set" -width 65 -height 15 -wrap word -bg white -fg black -takefocus 1
scrollbar .blog.sb -command ".blog.buffer yview"

frame .logwindow -borderwidth 2
text .logwindow.buffer  -yscrollcommand  ".logwindow.sb set" -width 65 -height 10 -wrap word -bg black -fg green -takefocus 1
scrollbar .logwindow.sb -command ".logwindow.buffer yview"
frame .bf
pack .logwindow -side bottom
pack .logwindow.sb -side right -fill y
pack .logwindow.buffer -side left

pack .mbf -side top
pack .mbf.new -side left -ipadx 45
pack .mbf.publish -side left -ipadx 45
pack .mbf.quit -side left -ipadx 45

pack .mba -side top
pack .mba.resend  -side left -ipadx 77
pack .mba.archive -side left -ipadx 77
if {$blggv::enable_archive==0} {
   .mba.archive config -state disabled
}

pack .blog
pack .blog.sb -side right -fill y
pack .blog.buffer -side left
raise .
focus .blog.buffer

set icofile TREX.ico

if {[file exists $icofile]} {
   set tmpfile "$icofile.~"
   set fin [open $icofile r]
   fconfigure $fin -translation binary
   set fout [open $tmpfile w]
   fconfigure $fout -translation binary
   puts -nonewline $fout [read $fin]
   close $fin
   close $fout
   set ico [winico create $tmpfile]
   winico setwindow . $ico
}
file delete $tmpfile


menu .popup -tearoff 0
set sortedmacros [array names macro]

foreach mtitle $sortedmacros {
        set mtext  $macro($mtitle)
        .popup add command -label $mtitle   -command \
        [list  .blog.buffer insert insert $mtext]
}


.popup add separator
.popup add command -label "Cut" -command \
       {
           set owner [selection own]
           set textw ".blog.buffer"
           if {$owner == $textw} {
               clipboard clear
               catch {
                      clipboard append [selection get]
                      $owner delete sel.first sel.last
               }
           }
       }

.popup add command -label "Copy" -command \
       {
           set owner [selection own]
           set textw ".blog.buffer"
           if {$owner == $textw} {
               clipboard clear
               catch {
                      clipboard append [selection get]
               }
           }
       }

.popup add command -label "Paste" -command \
       {
           set textw ".blog.buffer"
           catch { set clip [selection get -selection CLIPBOARD] }
           set idx [$textw index insert]
           set owner [selection own]

           if {$owner == $textw} {
               catch {
                      set idx [$owner index sel.first]
                      $textw delete sel.first sel.last
               }
           }
           catch { $textw insert $idx $clip }
       }

.popup add separator
set sortedexecs [array names launch]
foreach etitle $sortedexecs {
        set etext  $launch($etitle)
        .popup add command -label $etitle   -command \
        [list exec $etext]
}

bind .blog.buffer  <Button-3> {
     set gx [winfo rootx %W]
     set gy [winfo rooty %W]
     set mx [expr $gx + %x]
     set my [expr $gy + %y]
     tk_popup .popup $mx $my
}
logmsg "$blggv::version -- $blggv::start"
set  timestamp [clock format [clock seconds] -format "%d %b %H:%M:%S"]
.logwindow.buffer insert end  "  $timestamp  -- copyright 2002. by tony summerfelt. all rights reserved.\n"
if {![file exist $blggv::blogtemplate]} {
    wm iconify .
    tk_messageBox -title "ERROR!" -icon error -message  "Couldn't find \
                                                        $blggv::blogtemplate"
    logmsg "Couldn't find blog template $blggv::blogtemplate"
    exit
}
if {![file exists "tmp"]} {
    file mkdir "tmp"
    logmsg "Creating tmp directory"
}
if {![file exist "archive"]} {
      file mkdir "archive"
      logmsg "Creating archive directory"
}
